<?php

namespace Teknisa\CMP\Util;

class Attachment
{
    private $name;
    private $path;
    private $type;
    private $encoding;
    private $disposition;
    private $isStringAttachment;

    public function __construct($path, $name = '')
    {
        $this->name               = $name;
        $this->path               = $path;
        $this->type               = '';
        $this->encoding           = 'base64';
        $this->disposition        = 'attachment';
        $this->isStringAttachment = false;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function getPath()
    {
        return $this->path;
    }

    public function setPath($path)
    {
        $this->path = $path;
    }

    public function getFile()
    {
        if ($this->isStringAttachment) {
            return $this->my_file_get_contents($this->path);
        }

        return $this->path;
    }
    
    private function my_file_get_contents($site_url)
    {
        $ch = curl_init();
        $timeout = 0;
        
        curl_setopt($ch, CURLOPT_URL, $site_url);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
        
        ob_start();
        
        curl_exec($ch);
        curl_close($ch);
        
        $file_contents = ob_get_contents();
        
        ob_end_clean();
        
        return $file_contents;
    }

    public function getType()
    {
        return $this->type;
    }

    public function setType($type)
    {
        $this->type = $type;
    }

    public function getEncoding()
    {
        return $this->encoding;
    }

    public function setEncoding($encoding)
    {
        $this->encoding = $encoding;
    }

    public function getDisposition()
    {
        return $this->disposition;
    }

    public function setDisposition($disposition)
    {
        $this->disposition = $disposition;
    }

    public function isStringAttachment()
    {
        return $this->isStringAttachment;
    }

    public function setIsStringAttachment($isStringAttachment)
    {
        $this->isStringAttachment = $isStringAttachment;
    }
}